#! /bin/bash
#! /bin/bash
# DESCRIPTION:
# Simple script to monitor your EDPnet ADSL connection speed by doing the speedtest.edpnet.be test on a set interval
# This script uses an infinite loop with a while loop that never ends, which is crude, but makes it easy to employ
# Output is in CSV format optimized for Excel import, script does some simple log numbering as well

# USAGE:
# Best is to run in it the background with: edpspeedtest.sh &
# Don't forget it to kill it when your are done or it will run until the computer is restarted
# Use ps | grep edpspeedtest to find the process number to kill when you want to stop the script.

# EXCEL IMPORT:
# In Excel do > File > Import > CSV > Finish. Or manually specify the comma seperator and double quotes as field markers

# VARIABLES
TEMPRESULT_EDPNET=tempresult_edpnet
TEMPRESULT_TELENET=tempresult_telenet
TEMPDATA=tempdata
# CSV file name, csv extension automatically appended as well as a log number
CSV=speedtest-log
SEPERATOR=","
# If you want you can change the interval at which the test is run (in seconds)
INTERVAL=900
# Used for the infinite while loop
COUNTER=OMEGA

echo "Script running, infinite while loop in effect"

# Print header row and create log file
echo "\"Date and time\"$SEPERATOR\"Speed edpnet\"$SEPERATOR\"Unit\"$SEPERATOR\"Speed telenet\"$SEPERATOR\"Unit\"$SEPERATOR\" \"$SEPERATOR\"Modem speed edpnet\"$SEPERATOR\"Modem speed telenet\"$SEPERATOR\"Unit\"" >> $CSV.csv

while [ $COUNTER = OMEGA ]; do

   # Get speed already once to wake up the router
   DUMMY=$(/usr/bin/php ./bwmon-quimbey.php)
   # Execute the speedtest
   START=$(date +%s)
   wget -U "Mozilla/5.0 Littlebighuman.com/edpspeedtest.sh 1.0" -O $TEMPDATA "http://speedtest.edpnet.be/speedtest/random4000x4000.jpg" -o $TEMPRESULT_EDPNET
   END=$(date +%s)
   DIFF=$(( $END - $START ))
   MODEMSPEED_EDPNET=$(/usr/bin/php ./bwmon-quimbey.php $DIFF)
   rm $TEMPDATA
   
   START=$(date +%s)
   wget -U "Mozilla/5.0 Littlebighuman.com/edpspeedtest.sh 1.0" -O $TEMPDATA "http://speedtest.telenet.be/speedtest/random4000x4000.jpg" -o $TEMPRESULT_TELENET
   END=$(date +%s)
   DIFF=$(( $END - $START ))
   MODEMSPEED_TELENET=$(/usr/bin/php ./bwmon-quimbey.php $DIFF)
   rm $TEMPDATA
   
   # Get the line with the data we need
   DATALINE_EDPNET=$(cat "$TEMPRESULT_EDPNET" | awk '/'$TEMPDATA'’ saved/')
   DATALINE_TELENET=$(cat "$TEMPRESULT_TELENET" | awk '/'$TEMPDATA'’ saved/')

   # Empty TEMPFILE for the next while run
   rm $TEMPRESULT_EDPNET
   rm $TEMPRESULT_TELENET

   # Get the current time and date
   CURRENTDATE=$(date +"%d-%m-%Y %H:%M")

   # Get the speed in kbyte and replace the dot with a comma for Belgium international format
   SPEED_EDPNET=$(echo $DATALINE_EDPNET | awk '{print $3}' | sed '1s/^.//')
   UNIT_EDPNET=$(echo $DATALINE_EDPNET | awk '{print $4}' | sed 's/.$//')

   SPEED_TELENET=$(echo $DATALINE_TELENET | awk '{print $3}' | sed '1s/^.//')
   UNIT_TELENET=$(echo $DATALINE_TELENET | awk '{print $4}' | sed 's/.$//')

   # Output in CSV format
   echo "\"$CURRENTDATE\"$SEPERATOR\"$SPEED_EDPNET\"$SEPERATOR\"$UNIT_EDPNET\"$SEPERATOR\"$SPEED_TELENET\"$SEPERATOR\"$UNIT_TELENET\"$SEPERATOR\" \"$SEPERATOR\"$MODEMSPEED_EDPNET\"$SEPERATOR\"$MODEMSPEED_TELENET\"$SEPERATOR\"MB/s\"" >> $CSV.csv
   
   # Sleep
   sleep $INTERVAL
done 
